<template src="./template.html"></template>

<script lang="ts">
import { getModule, Watch } from "nuxt-property-decorator";
import { Vue, Component, Prop } from "vue-property-decorator";
import CountryFlag from "vue-country-flag";
import axios from "axios";
import { apiErrorHandler, redirectPage } from "@/utils/apiHanlers";
import AdminProductModule from "~/store/adminCollection";
import { api } from "~/common/constaint";
import _ from "lodash";
var momentz = require("moment-timezone");
var moment = require("moment");
@Component({})
export default class adminReviewComponent extends Vue {
  tab = 0;
  loadngTable = false;
  config = {
    limit: 25,
    page: 1,
    search: "",
    productId: "",
    approved: false,
  };
  totalPage = 1;
  page = 1;
  listApproved = [
    { name: "Approved", value: true },
    { name: "Not approved", value: false },
  ];

  listReview = [];
  dialogDeleteReview = false;
  mounted() {
    this.onGetListReview();
  }

  async onGetListReview() {
    try {
      this.loadngTable = true;
      const response = await this.$api.product.getListReview(this.config);
      if (response?.data?.data) {
        const { total } = response.data;
        this.totalPage = Math.ceil(total / this.config.limit);
        this.listReview = response.data.data;
      }
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loadngTable = false;
    }
  }
  loadingId = "";
  reviewId = "";
  loading = false;
  async onApproved(reviewId: string) {
    try {
      this.loadingId = reviewId;
      await this.$api.product.approvedReview(reviewId, true);
      this.$pushNotification.success("Approved review successfully");
      this.onGetListReview();
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loadingId = "";
    }
  }

  openDialogDelete(reviewId: string) {
    this.reviewId = reviewId;
    this.dialogDeleteReview = true;
  }

  async onDeleteReview() {
    try {
      this.loading = true;
      await this.$api.product.deleteReview(this.reviewId);
      this.$pushNotification.success("Delete review successfully");
      this.dialogDeleteReview = false;
      this.onGetListReview();
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loading = false;
    }
  }
  onRedirectPage() {
    this.config.page = this.page;
    this.onGetListReview();
  }

  convertImage(url: string) {
    return `${api}/${url}`;
  }

  formatDate(date: string) {
    return moment(date).format("HH:mm DD/MM/YYYY");
  }

  @Watch("tab")
  changedTab(value: number) {
    if (value === 0) {
      this.config.approved = false;
    } else {
      {
        this.config.approved = true;
      }
    }
    this.onGetListReview();
  }
}
</script>

<style></style>
